    # File lib/active_support/cache/strategy/local_cache.rb, line 35
            def read(key, options = nil)
              value = local_cache && local_cache.read(key)
              if value == NULL
                nil
              elsif value.nil?
                value = super
                local_cache.write(key, value || NULL) if local_cache
                value
              else
                # forcing the value to be immutable
                value.duplicable? ? value.dup : value
              end
            end